package com.njcn.gather.err.service;

import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.extension.service.IService;
import com.njcn.gather.err.pojo.param.PqErrSysParam;
import com.njcn.gather.err.pojo.po.PqErrSys;
import com.njcn.gather.err.pojo.vo.PqErrSysDtlsVO;

import java.util.List;
import java.util.Map;

/**
 * @author caozehui
 * @date 2024-11-27
 */
public interface IPqErrSysService extends IService<PqErrSys> {

    /**
     * 分页查询误差体系列表
     *
     * @param param 分页查询参数
     * @return 分页查询结果
     */
    Page<PqErrSys> listPqErrSys(PqErrSysParam.QueryParam param);

    /**
     * 根据id查询误差体系
     *
     * @param id id
     * @return 误差体系
     */
    PqErrSys getPqErrSysById(String id);

    /**
     * 新增误差体系
     *
     * @param param 新增参数
     * @return 成功返回true，失败返回false
     */
    boolean addPqErrSys(PqErrSysParam param);

    /**
     * 更新误差体系
     *
     * @param param 更新参数
     * @return 成功返回true，失败返回false
     */
    boolean updatePqErrSys(PqErrSysParam.UpdateParam param);

    /**
     * 删除误差体系
     *
     * @param ids id列表
     * @return 成功返回true，失败返回false
     */
    boolean deletePqErrSys(List<String> ids);

    List<PqErrSysDtlsVO> getDetail(String id);

    /**
     * 获取所有误差体系
     *
     * @return 误差体系列表
     */
    List<Map<String, Object>> listAllPqErrSys();

    /**
     * 根据误差体系名称查询误差体系
     *
     * @param name 误差体系名称
     * @return 误差体系
     */
    PqErrSys getPqErrSysByName(String name);

    /**
     * 复制误差体系
     *
     * @param id 误差体系id
     * @return 成功返回true，失败返回false
     */
    boolean copyPqErrSys(String id);

    /**
     * 根据id获取测试项列表
     *
     * @param id 误差体系id
     * @return
     */
    Map<String, String> getTestItems(String id);
}
